searchData={"items":[{"type":"module","title":"Acmev2","doc":"Implementation of the ACMEv2 protocol for Zerossl (on Elliptic Curves cryptography)","ref":"Acmev2.html"},{"type":"function","title":"Acmev2.cert_print/1","doc":"Print a certificate content","ref":"Acmev2.html#cert_print/1"},{"type":"macro","title":"Acmev2.csr/1","doc":"","ref":"Acmev2.html#csr/1"},{"type":"macro","title":"Acmev2.csr/2","doc":"","ref":"Acmev2.html#csr/2"},{"type":"macro","title":"Acmev2.ecdsa_key/1","doc":"","ref":"Acmev2.html#ecdsa_key/1"},{"type":"macro","title":"Acmev2.ecdsa_key/2","doc":"","ref":"Acmev2.html#ecdsa_key/2"},{"type":"macro","title":"Acmev2.ecdsa_signature/1","doc":"","ref":"Acmev2.html#ecdsa_signature/1"},{"type":"macro","title":"Acmev2.ecdsa_signature/2","doc":"","ref":"Acmev2.html#ecdsa_signature/2"},{"type":"function","title":"Acmev2.gen_cert/1","doc":"Generates a certificate through ACMEv2 protocol for the specified domain.\n\nThe following ACMEv2 providers are supported\n\n- `:zerossl` [*]\n- `:letsencrypt`\n- `:letsencrypt_test`\n\nZerossl requires EAB (External Account Binding) prior to issue a certificate:\nyou will have to register with a proper email to it. Once you've\ncreated an account, you can either provide the email or the account key (I've\nseen it called \"access key\" or \"API key\" around) in the configuration.\nThe code tries to lookup for the email, and when not found, defaults\nto the `:account_key`. You can find your account key (called API key in zerossl)\nhere:\n\n    https://app.zerossl.com/developer\n\n\nTo perform the authentication the EAB credentails must be retrieved.\nThese are saved on a file `eab_credentials.json` to be reused\nfor the following interactions with Zerossl service APIs\n\nThe authentication method relies on the HTTP (not DNS). For it to work\n`gen_cert` opens a listening socket on port 80 where it serves the\nwell-known file retrieved from the APIs exchange. When the procedure\ncompletes the socket is closed.\n\nBy demonstrating the ownership of the site the user gets trusted by\nthe Zerossl service and the certificate is emitted.\n\nThe function returns a key and its related certificate. Those\ncan be used to run a trusted HTTPs server.\n\nThe key and certificate values are in binary encoded format and can be\ndirectly written on a file","ref":"Acmev2.html#gen_cert/1"},{"type":"function","title":"Acmev2.jws_dec/1","doc":"Print a JWS content","ref":"Acmev2.html#jws_dec/1"},{"type":"module","title":"Certmgr","doc":"Manager of the status of the certificate. This genserver maintains\na timer to renew the certificate one day ahead of expiration.\n\nIf a certificate is not found in path, it is immediately generated.\n\nAdditionally, by specifying an `:update_handler` in the `:zerossl`\nconfiguration it's possible for an application to get notified about\ncertificate generation/renewal.","ref":"Certmgr.html"},{"type":"function","title":"Certmgr.child_spec/1","doc":"Childspec of Certmgr genserver","ref":"Certmgr.html#child_spec/1"},{"type":"function","title":"Certmgr.days_left/1","doc":"","ref":"Certmgr.html#days_left/1"},{"type":"function","title":"Certmgr.manage_cert_renewal/0","doc":"Manage the certificate renewal by checking it's not_before and not_after Validities.\n\nEvery time the certificate has less than one day of validity, a renewal is issued.\nOtherwise a timer is set to wait until the moment such last day of validity is reached,\nto trigger the renewal again.","ref":"Certmgr.html#manage_cert_renewal/0"},{"type":"function","title":"Certmgr.read_cert/0","doc":"Read key and certificate from file, or raise an error if\nit does not find them","ref":"Certmgr.html#read_cert/0"},{"type":"function","title":"Certmgr.start_link/1","doc":"","ref":"Certmgr.html#start_link/1"},{"type":"function","title":"Certmgr.write_cert/2","doc":"Write key and certificate to the files specified by the config","ref":"Certmgr.html#write_cert/2"},{"type":"module","title":"Selfsigned","doc":"Module to issue certificate with arbitrary lifetime\n\nThis module serves testing purposes.","ref":"Selfsigned.html"},{"type":"function","title":"Selfsigned.gen_cert/2","doc":"Generate a self-signed 2048 bit RSA key X509 certificate for testing purposes","ref":"Selfsigned.html#gen_cert/2"},{"type":"module","title":"ZerosslSup","doc":"Zerossl Supervisor managing the Certmgr genserver","ref":"ZerosslSup.html"},{"type":"function","title":"ZerosslSup.start/2","doc":"","ref":"ZerosslSup.html#start/2"},{"type":"behaviour","title":"ZerosslSup.UpdateHandler","doc":"","ref":"ZerosslSup.UpdateHandler.html"},{"type":"callback","title":"ZerosslSup.UpdateHandler.update/2","doc":"","ref":"ZerosslSup.UpdateHandler.html#c:update/2"},{"type":"extras","title":"Zerossl client library","doc":"# Zerossl client library\n\nZerossl is a Elixir library to automatically manage and refresh your Zerossl and Letsencrypt certificates natively, without the need for extra applications like [acme.sh](https://github.com/acmesh-official/acme.sh)  bash script or [certbot](https://certbot.eff.org/) clients.\nThe client implements the [ACME(v2) rfc8555](https://datatracker.ietf.org/doc/html/rfc8555) `http-01` challenge auth mechanism to issue and refresh a genuine certificate against [Zerossl](https://zerossl.com/)","ref":"readme.html"},{"type":"extras","title":"Installation - Zerossl client library","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed by adding `zerossl` \nto your list of dependencies in `mix.exs`:\n\n  \n```elixir\ndef  deps  do\n[\n  {:zerossl, \"~> 1.0.0\"}\n]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Zerossl client library","doc":"In your `config.exs` or `prod.exs` add the following config:\n\n```elixir\nconfig  :zerossl,\n  provider: :letsencrypt\n  cert_domain:  \"myfancy-domain.com\",\n  certfile:  \"./cert.pem\",\n  keyfile:  \"./key.pem\"\n```\nwhere\n* `provider` is `:zerossl` (default), `:letsenctypt` or `:letsencrypt_test`\n* `cert_domain` is the domain that resolves your software application project, and for which you want to issue the certificate\n* `certfile` and `keyfile` are the places where you want to store your certificate and key respectively.\n\nKey and certificate are always stored on FS to avoid regenerating them upon reboot.\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Additional optional config - Zerossl client library","doc":"* `port`, [default: `80`] optional listening port for serving the well-known secret token.\n* `addr`, [default: `0.0.0.0`] optinal listenening ip address for serving well-known secret token.\n* `selfsigned` [default: `false`]: forces \"dryrun\" selfsigned certificate generation without an actual exchange with a certificate provider (used for testing).\n* `update_handler` [default: `nil`]: permits to specify a module that implements the `Zerossl.UpdateHandler` behavior to get notifications when the certificate is renewed. This can be used as trigger to reload a listening HTTPs server with the new certificate/key. The handler is always invoked upon start of the process: subordinating the start of the HTTPs server to the call by this handler is legitimate.\n* `user_email` email used to request EABs;\n* `account_key`: for Zerossl certificate provider it is possible to use an account_key in place of the `:user_email` to retrieve EAB credentials [getting EAB credentials](https://zerossl.com/documentation/acme/generate-eab-credentials/). \n\nThe `:user_email` and `:account_key` are not required for providers that do not requre EAB (such as letsencrypt). When the provider requires EAB and none of these settings keys are configured, the application raises an exception.","ref":"readme.html#additional-optional-config"}],"content_type":"text/markdown"}